\(k\)-means is a well-known clustering algorithm: it partitions a set of points into \(k\) clusters
to minimize the sum of squared distances from each data point being clustered to its closest cluster center. 

The standard algorithm given in Algorithm \ref{alg:kmeans} was first proposed by Stuart Lloyd in 1957 and published in 1982 \cite{lloyd1982least}.
In this algorithm, \(k\) is the number of clusters, \(data\) is the set of points, and \(\delta\) is a convergence criteria, as it uses an iterative technique.
The Euclidean distance is referred as \(d\).
Using the same notations as in the algorithm, the objective is:

\[ \argmin\limits_C \sum\limits_{i=1}^k \sum\limits_{p \in C_i} d(p, c_i) \]

These different steps are performed:

\begin{enumerate}
	\item Choose initial centroids
	\item Assign each point to the nearest centroid
	\item Update the centroid of each cluster
	\item Repeat 2 and 3 until the convergence criteria is met
	\item Return the clusters
\end{enumerate}


This algorithm has a polynomial complexity, but it can return a local optimum.
This depends on the initialisation of the first centroids.
Finding an optimal solution is however NP-hard \cite{Aloise:2009:NES:1519378.1519389}.


\begin{algorithm}
\begin{algorithmic}
\Function{KMeans}{\(k\), \(data\), $\delta$}
\State Choose \( \tilde{C} := \left( \tilde{c_1} \ldots \tilde{c_k} \right) \) initial centroids
\Repeat
\State \( C = \tilde{C} \) 
\ForAll {point \( p \in data \)}
	\State \( j := \argmin_i \, d(p, c_i) \)
	\Comment {Find nearest cluster}
	\State Assign \( p \) to cluster \( C_j \)
\EndFor
\ForAll {\( i\) in \( \{ 1 \ldots k \} \)}
	\State \( \tilde{c_i} = mean(p \in C_i) \)
	\Comment {Compute new centroids}
\EndFor
\Until \( \vert \tilde{C} - C \vert \leq \delta \)
\Comment {Convergence criteria}
\State \Return \( \tilde{C} \)
\Comment {Return the final centroids}
\EndFunction
\end{algorithmic}
\caption{K-Means Standard Algorithm}
\label{alg:kmeans}
\end{algorithm}